#include <xcore/port.h>
#include <xcore/clock.h>
#include <xs1.h>

port_t outP    = XS1_PORT_8A;
port_t inClock = XS1_PORT_1A;
xclock_t clk   = XS1_CLKBLK_1;
  
int main(void) {
    port_start_buffered(outP, 32);
    port_enable(inClock);
    clock_enable(clk);

    clock_set_source_port(clk, inClock);
    port_out(outP, 0);
    port_set_clock(outP, clk);

    clock_start(clk);
    
    port_out(outP, 0xAA00FFFF);
    port_out(outP, 0x12345678);
    port_out(outP, 0x55AAA111);
    port_sync(outP);            // Used to wait before stopping the program
}
