#include <xcore/port.h>
#include <xcore/clock.h>
#include <stdio.h>
#include <xs1.h>
  
port_t inP      = XS1_PORT_4C;
port_t outClock = XS1_PORT_1E;
xclock_t clk25  = XS1_CLKBLK_1;
  
int main(void) {
    port_start_buffered(inP, 8);
    port_enable(outClock);
    clock_enable(clk25);

    clock_set_divide(clk25, 2); // divide by 4, 25 MHz
    port_set_clock(inP, clk25);
    port_set_clock(outClock, clk25);
    port_set_out_clock(outClock);
    clock_start(clk25);

    int data[10];
    for(int i = 0; i < 10; i++) {
        data[i] = port_in(inP);
    }
    for(int i = 0; i < 10; i++) {
        printf("<%02x>\n", data[i]);
    }    
}
