#include <xcore/port.h>
#include <xcore/port_protocol.h>
#include <xcore/clock.h>
#include <xs1.h>
#include <stdio.h>
  
port_t inP     = XS1_PORT_4C;
port_t inReady = XS1_PORT_1B;
port_t inClock = XS1_PORT_1A;
xclock_t clk   = XS1_CLKBLK_1;
  
int main(void) {
    port_start_buffered(inP, 8);
    port_enable(inReady);
    port_enable(inClock);
    clock_enable(clk);

    clock_set_source_port(clk, inClock);
    port_protocol_in_strobed_slave(inP, inReady, clk);
    clock_start(clk);

    int data0 = port_in(inP);
    int data1 = port_in(inP);
    printf("%02x %02x\n", data0, data1);
}
