#include <xcore/parallel.h>
#include <xcore/channel.h>
#include <stdio.h>

extern void miiReceiveFrame(char *pkt);
extern void miiTransmitFrame(char *pkt);
extern void miiConfigReceive();
extern void miiConfigTransmit();

DECLARE_JOB(rx, (void));
DECLARE_JOB(tx, (void));

void rx() {
    char data[100];
    miiConfigReceive();
    miiReceiveFrame(data);
    int len = ((int *)data)[0];
    printf("%d bytes: ", len);
    for(int i = 0; i < len; i++) {
        printf("<%02x> ", data[4+i]);
    }
    printf("\n");
}

void tx() {
    char data[100];
    for(int i = 0; i < 19; i++) {
        data[i+4] = i+0x80;
    }
    ((int *)data)[0] = 19;
    miiConfigTransmit();
    miiTransmitFrame(data);
}

int main()
{
    PAR_JOBS(
        PJOB(tx, ()),
        PJOB(rx, ()));
}
