//start_config
#include <xcore/port.h>
#include <xcore/port_protocol.h>
#include <xcore/clock.h>
#include <xs1.h>

port_t TX_D   = XS1_PORT_4B;
port_t TX_EN  = XS1_PORT_1K;
port_t TX_CLK = XS1_PORT_1J;
static xclock_t clk  = XS1_CLKBLK_1;

void miiConfigTransmit() {
    port_start_buffered(TX_D, 32);
    port_enable(TX_CLK);
    port_enable(TX_EN);
    clock_enable(clk);    

    clock_set_source_port(clk, TX_CLK);
    port_protocol_out_strobed_master(TX_D, TX_EN, clk, 0);
    clock_start(clk);
}
//end_config

//start_tx_frame
#include <xcore/select.h>

void miiTransmitFrame(char *cpkt) {
	int numBytes, tailBytes, tailBits, data;
    int *pkt = (int *)cpkt;

    /* Input size of next packet */
    numBytes = *pkt++;
    tailBytes = numBytes % 4;
    tailBits = tailBytes * 8;
        
    /* Output row of 0x5s followed by 0xD */
    port_out(TX_D, 0xD5555555);

    /* Output 32-bit words for serialization */
    for (int i=0; i<numBytes-tailBytes; i+=4) {
        data = *pkt++;  
        port_out(TX_D, data);
    }

    /* Output remaining bits of data for serialization */
    if (tailBits != 0) {
        data = *pkt;
        port_out_part_word(TX_D, data, tailBits);
    }
    printstr("Done\n");
}
//end_tx_frame
